/* 
This Class implements the mathematical operations involved in Repairing failed nodes and Re-constructing file
from a MSR Code using Product Matrix Construction. 
*/


import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.Arrays;
import java.util.Random;


import javax.swing.JTextField;


public class productmatrix extends JFrame {

		private JLabel n,k,alpha_jlabel,B_jlabel,d_jlabel,prime_jlabel,path_jlabel,path_output_jlabel;
		private JTextField n1,k1,d1,alpha_jtextfield,B_jtextfield,d_jtextfield,prime_jtextfield,path_jtextfield,path_output_jtextfield;
		private JButton submit;
		public JTextField   _fileNameTF  = new JTextField(15);
		public JFileChooser _fileChooser = new JFileChooser();
		
		public long flag = 0;
		
		public productmatrix(){
			super("MSR");
			
			setLayout(new FlowLayout());
			JPanel panel = new JPanel();
			
			panel.setLayout(new GridBagLayout());
			GridBagConstraints c = new GridBagConstraints();
			
			c.gridx = 0;
			c.gridy = 0;
			n = new JLabel("Enter number of nodes (n) ==>");
			n1 = new JTextField(10);
			n1.setToolTipText("Enter number of nodes ==>");
			panel.add(n, c);
			c.gridx = 3;
			c.gridy = 0;
			panel.add(n1, c);
			
			k = new JLabel("Enter number of nodes used to reconstruct a file (k)==> ");
			k1 = new JTextField(10);
			k1.setToolTipText("Enter number of nodes used to reconstruct a file (k)");
			c.gridx = 0;
			c.gridy = 2;
			panel.add(k, c);
			c.gridx = 3;
			c.gridy = 2;
			panel.add(k1, c);
			
						
			prime_jlabel = new JLabel("Enter value of p (prime)");
			prime_jtextfield = new JTextField(10);
			prime_jtextfield.setToolTipText("Enter value of p (prime)");
			c.gridx = 0;
			c.gridy = 4;
			panel.add(prime_jlabel,c);
			c.gridx = 3;
			c.gridy = 4;
			panel.add(prime_jtextfield,c);
			
			_fileNameTF.setToolTipText("Upload the File");
			_fileNameTF.setEditable(false);
			JButton upload = new JButton ("Upload File");
			c.gridx = 3;
			c.gridy = 8;
			panel.add(_fileNameTF,c);
			c.gridx = 0;
			c.gridy = 8;
			panel.add(upload,c);
			
			upload.addActionListener(new OpenAction());
			
			path_jlabel = new JLabel("Enter path for creating simulation file");
			path_jtextfield = new JTextField(30);
			path_jtextfield.setToolTipText("Enter path");
			c.gridx = 0;
			c.gridy = 10;
			panel.add(path_jlabel,c);
			c.gridx = 3;
			c.gridy = 10;
			panel.add(path_jtextfield,c);
			
			path_output_jlabel = new JLabel("Enter path for Regenerating File");
			path_output_jtextfield = new JTextField(30);
			path_jtextfield.setToolTipText("Enter path");
			c.gridx = 0;
			c.gridy = 12;
			panel.add(path_output_jlabel,c);
			c.gridx = 3;
			c.gridy = 12;
			panel.add(path_output_jtextfield,c);
			
			
			
			submit = new JButton("Simulation Report");
			c.gridx = 0;
			c.gridy = 14;
			panel.add(submit,c);
			
			JButton generate_values = new JButton("Generate Value");
			c.gridx = 3;
			c.gridy = 14;
			panel.add(generate_values,c);
			
			generate_values.addActionListener(new GenerateValues());
//-----------------------------------------------------------			
			
					
	
			subhandler submit1 = new subhandler();
			
						
		
			submit.addActionListener(submit1);
			
			
			c.gridx = 0;
			c.gridy = 16;
			alpha_jlabel = new JLabel("Number of Chunks Stored at each node (alpha)==> ");
			alpha_jlabel.setVisible(false);
			panel.add(alpha_jlabel, c);
			c.gridx = 3;
			c.gridy = 16;
			alpha_jtextfield =  new JTextField("0",10);
			alpha_jtextfield.setEditable(false);
			alpha_jtextfield.setVisible(false);
			panel.add(alpha_jtextfield, c);
			
			
			c.gridx = 0;
			c.gridy = 18;
			B_jlabel = new JLabel("Maximum File Size the cloud can store (B)==> ");
			B_jlabel.setVisible(false);
			panel.add(B_jlabel, c);
			
			c.gridx = 3;
			c.gridy = 18;
			B_jtextfield =  new JTextField("0",10);
			B_jtextfield.setEditable(false);
			
			panel.add(B_jtextfield, c);
			B_jtextfield.setVisible(false);
			
			c.gridx = 0;
			c.gridy = 20;
			d_jlabel = new JLabel("Number of nodes used to reconstruct a node (d)==> ");
			d_jlabel.setVisible(false);
			panel.add(d_jlabel,c);
			
			c.gridx = 3;
			c.gridy = 20;
			d_jtextfield =  new JTextField("0",10);
			d_jtextfield.setEditable(false);
			panel.add(d_jtextfield, c);
			d_jtextfield.setVisible(false);
			
						
			add(panel);
			
			
			 
		}
		
	
		
		public class subhandler implements ActionListener {

			
			public String n,k,p ="";
			int n2,k2,d2,alpha,p2;
			int B=0,flag_prime=0;
			
			
			
			@Override
			public void actionPerformed(ActionEvent event) {
				// TODO Auto-generated method stub
				
				flag = 1;
				
				n=n1.getText();
				k=k1.getText();
				
				p=prime_jtextfield.getText();
				
				
				n2 = Integer.parseInt(n);
				k2 = Integer.parseInt(k);
				
				p2= Integer.parseInt(p);
				
				flag_prime = prime(p2);
				
				
				d2 = 2*(k2-1);	
								
				if (n2<=0)
				{
		                 JOptionPane.showMessageDialog(null,
		                         "Error: Please enter number greater than 0", "Error Massage",
		                         JOptionPane.ERROR_MESSAGE);
		                 flag = -1;
				}    
				else if(k2>n2) 
				{
	                 JOptionPane.showMessageDialog(null,
	                         "Error: Please enter value of k less than n", "Error Massage",
	                         JOptionPane.ERROR_MESSAGE);
				}
	            
	            else if(flag_prime==0)
				{
					JOptionPane.showMessageDialog(null,
	                         "Error: Please enter prime number", "Error Massage",
	                         JOptionPane.ERROR_MESSAGE);
	                 flag = -1;
				}
	            else if(p2<(n2*(d2-k2+1))){
	            	
	            	JOptionPane.showMessageDialog(null,
	                         "Error: Please enter a value of p larger than"+(n2*(d2-k2+1)), "Error Massage",
	                         JOptionPane.ERROR_MESSAGE);
	                 flag = -1;
	            }
					
					
					if (flag==1)
					{
						
						alpha = k2-1;
						B = (alpha*(alpha+1));
						
						/*alpha_jtextfield.setVisible(true);
						alpha_jlabel.setVisible(true);
						B_jtextfield.setVisible(true);
						B_jlabel.setVisible(true);
						d_jtextfield.setVisible(true);
						d_jlabel.setVisible(true);
						alpha_jtextfield.setText(""+alpha);
						B_jtextfield.setText(""+B);
						d_jtextfield.setText(""+d2);*/
						
						
						
						long[] file_data = new long[B];
						int file_counter =0;
						
						File file1 = _fileChooser.getSelectedFile();
						
						File file = new File(file1.getPath());
						
						long File_upload_startTime = System.currentTimeMillis();
						DataInputStream in;
						try {
							in = new DataInputStream(new FileInputStream(file));
							
							while(file_counter<B)
							{
						
								file_data[file_counter] = (int) in.readByte();
								file_counter++;
							} 
							
						in.close();
							
					
						} catch (FileNotFoundException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						System.out.println("file data");

						System.out.println(Arrays.toString(file_data));
						

						Writer out = null;
						File report = new File(path_jtextfield.getText());
						try {
						out = new BufferedWriter(new FileWriter(report));
						

						
						long [] [] S1 = new long [alpha] [alpha];
						
						long [] [] S2 = new long [alpha] [alpha];
						
						int p=0;
						p=(((alpha+1)*alpha)/2);
					
						int i,j=0;
						long temp=0;
						
						for(j=0;j<alpha;j++){
							for(i=0;i<alpha-j;i++){
								S1[j][i+j] = (int) file_data[(int) (temp)];
								temp++;
							}
							
						}
						
						for(i= 0; i < alpha;i ++){
							for(j=0;j <i ; j++){
								S1[i][j] = S1[j][i];
								
							}
							
						}
						
											
						
						for (i=0;i<alpha;i++) {
							for(j=0;j<alpha;j++)
							{
								System.out.print(S1[i][j]+" ");
								
															
							}
							System.out.print("\n");
						}
						
						temp=0;
						
						for(j=0;j<alpha;j++){
							for(i=0;i<alpha-j;i++){
								S2[j][i+j] = file_data[(int) (p+temp)];
								temp++;
							}
							
						}
						
						for(i= 0; i < alpha;i ++){
							for(j=0;j <i ; j++){
								S2[i][j] = S2[j][i];
								
							}
							
						}
						
											
						
						for (i=0;i<alpha;i++) {
							for(j=0;j<alpha;j++)
							{
								System.out.print(S2[i][j]+" ");
								
															
							}
							System.out.print("\n");
						}
						
										
						
						
						
						long [][] M = new long [d2][alpha];
						
						for(i=0;i<alpha;i++)
							for(j=0;j<alpha;j++){
								M[i][j]=S1[i][j];
							}
						for(i=(alpha);i<2*alpha;i++)
							for(j=0;j<alpha;j++){
								M[i][j]=S2[i-alpha][j];
							}
						
						System.out.print("Message Matrix==>\n");
						
						for(i=0;i<d2;i++){
							
						
							for(j=0;j<alpha;j++)
							{
								System.out.print(M[i][j]+" ");
						
							}
							System.out.print("\n");
						}
						System.out.print("\n");
						
						
				//-------------------sai Matrix/Vandermonde matrix-----------------------		
						long [][] sai = new long[n2][d2];
						
						
						int x;
						int y;
							
						for(x=0;x<n2;x++){
							for(y=0;y<d2;y++){
								
									//sai[x][y]=(long)(Math.pow((x+1),y)%p2);
						 
								sai[x][y]=1;
								for (int z=1;z<=y;z++)
									sai[x][y]=(sai[x][y]*(x+1))%p2;
								
							}
						}
						System.out.print("Vandermonde Matrix==>\n");
										
						for(x=0;x<n2;x++)
						{
							
						
							for(y=0;y<d2;y++)
							{
								System.out.print(sai[x][y]+" ");
							}
						System.out.print("\n");
						}
						System.out.print("\n");
		//-------------------sai Matrix-----------------------
						
		//-------------------C Matrix-----------------------
						long [][] C = new long[n2][alpha];
						Random rand = new Random();
						int min=0, max=1000;

						for(i = 0; i < n2; i++) { // aRow
						    for(j = 0; j < alpha; j++) { // bColumn
						      for(int k = 0; k < d2; k++) { // aColumn
						        
						    	  C[i][j] += (sai[i][k]*M[k][j])%p2;
						    	 	    	       
						        
						      }
						      C[i][j]%=p2;
						    
						    }
						    int randomNum = rand.nextInt(max - min + 1) + min;
						    try {
								Thread.sleep(randomNum);
							} catch (InterruptedException e2) {
								// TODO Auto-generated catch block
								e2.printStackTrace();
							}
							System.out.println("Random Delay==>"+randomNum+"\n");
						  }
						
						long File_upload_endTime = System.currentTimeMillis();
						
						System.out.print("C matrix==>\n");
						for(i = 0; i < n2; i++) { // aRow
						    for(j = 0; j < alpha; j++) { // bColumn
						   	       System.out.print(C[i][j]+"   ");
						        
						      }
						    System.out.print("\n\n");
						    }
						  

						   
		//----------- For Constructing Y--------
						    
						    //System.out.print("Node failed matrix==>\n");
							Random nodefail_generate = new Random();
							
							int num_of_fail_nodes = nodefail_generate.nextInt(n2-d2)+1;
							int [] nodefail = new int [num_of_fail_nodes];
							i=0;
							while(i<num_of_fail_nodes){
								int random = (nodefail_generate.nextInt(n2)+1);
								System.out.print("\nrandom==>"+random+"\n");
						    	boolean flag = false;
						    	for (j=0;j<i;j++){
						    		if(nodefail[j]==random)
						    			flag=true;
						    	}
						    	if(flag)
						    	{
						    		continue;
						    	}
						    	else {nodefail[i]=random;
						    	i++;
						    		
						    	}
														
							}
							Arrays.sort(nodefail);
							System.out.print("\nNume of failed nodes==>"+num_of_fail_nodes+"\n");
							System.out.print("\n Node number which is failed ==>"+Arrays.toString(nodefail)+"\n");
						    
							long Node_repair_startTime = System.currentTimeMillis();
							long [] [] y1 = new long [num_of_fail_nodes] [alpha];
							long [] [] delta = new long [n2] [n2];
							
							for(i=0;i<n2;i++){
								delta[i][i]=1;
								for (int l=1;l<=alpha;l++)
									delta[i][i]=(delta[i][i]*(i+1))%p2;
//								delta[i][i] = ((int)Math.pow(i+1, alpha))%p2;
								
								
								                            
							}
							
	                   for(i=0;i<n2;i++){
	                	   for(j=0;j<n2;j++){
	                		   System.out.print(delta[i][j]+" ");
	                   }
	                	   System.out.print("\n");
								                            
							}
							long [] [] phi = new long [n2] [alpha];
							
							for(i=0;i<n2;i++){
								for(j=0;j<alpha;j++){
									
								
								phi[i][j] = sai[i][j];
								
								System.out.print(phi[i][j]+" ");
								}                            
								System.out.print("\n");
							}
							for(i=0;i<num_of_fail_nodes;i++){
								for(j=0;j<alpha;j++){
									
								
								y1[i][j] = phi[nodefail[i]-1][j];
								
								System.out.print(y1[i][j]+" ");
								}                            
								System.out.print("\n");
							}
						    
						    
						    System.out.print("\n\n");
						    System.out.print("Nodes which required to repair==>\n");
						    long [] [] y2 = new long [d2][alpha];
						    Random a1 = new Random();
						    int [] contactnode = new int [d2];
						    i=0;
						    while(i<d2){
						    	
						    	int random = (a1.nextInt(n2)+1);
						   
						    	boolean check_new = false;
						    	boolean check_working = false; 
						    	for (j=0;j<i;j++){
						    		if(contactnode[j]==random)
						    			check_new=true;
						    			
						    	}
						    	for (j=0;j<num_of_fail_nodes;j++){
						    		if(nodefail[j]==random)
						    			check_working=true;
						    			
						    	}
						    	
						    	if(check_new || check_working)
						    	{
						    		continue;
						    	}
						    	else {contactnode[i]=random;
						    		i++;
						    	}
						    }
						    Arrays.sort(contactnode);
						    System.out.println(Arrays.toString(contactnode));
						    				    
						    for(i=0;i<d2;i++){
						    	for(j=0;j<alpha;j++){
						    		y2[i][j] = C[contactnode[i]-1][j];
						    	}
						    	
						    	
						    }
						    
						    
						    for(i=0;i<d2;i++){
						    	for(j=0;j<alpha;j++){
						    		System.out.print(y2[i][j]+" ");
						    	}
						    	
						    		System.out.print("\n");
						    }
						    double [] [] DC = new double [d2][num_of_fail_nodes]; 
						    
						    for(i = 0; i < d2; i++) { // aRow
							    for(j = 0; j < num_of_fail_nodes; j++) { // bColumn
							    	for(int k=0;k<alpha;k++) {
							        DC [i][j] += (y2[i][k]*y1[j][k])%p2;							    	  
							    	}
							    	DC [i][j] %=p2;	
							    }
							    
							    int randomNum = rand.nextInt(max - min + 1) + min;
							    try {
									Thread.sleep(randomNum);
								} catch (InterruptedException e2) {
									// TODO Auto-generated catch block
									e2.printStackTrace();
								}
								System.out.println("Random Delay==>"+randomNum+"\n");
							    
							  }
						    
						    System.out.println("printing DC ==>");
						    for(i = 0; i < d2; i++) { // aRow
							    for(j = 0; j < num_of_fail_nodes; j++) { // bColumn
							    	
							    	 System.out.print(DC[i][j]+" ");						    	  
							   
							    }
							    System.out.print("\n");	
							  }
						   
						    
						    int[][] sai_repair = new int [d2][d2];

						    int [] [] sai_repair_inverse = new int [d2][d2];
						    
							temp =0;
						    for(i=0;i<d2;i++){
						    	for(j=0;j<d2;j++){
						    		sai_repair[i][j] = (int) sai[contactnode[i]-1][j];
						    		
						    	}
						    }
						    
						    vandermonde_inverse(sai_repair,sai_repair_inverse,p2);
						    
							
							
							float [] [] result = new float [d2][num_of_fail_nodes];
							
							
							for(i = 0; i < d2; i++) { // aRow
								    for(j = 0; j < num_of_fail_nodes ; j++) { // bColumn
								      for(int k=0;k<d2;k++){
								        result [i][j] += (sai_repair_inverse[i][k]*DC[k][j])%p2;
								        
								      }
									   result[i][j] %=p2;
								    }
								    int randomNum = rand.nextInt(max - min + 1) + min;
								    try {
										Thread.sleep(randomNum);
									} catch (InterruptedException e2) {
										// TODO Auto-generated catch block
										e2.printStackTrace();
									}
									System.out.println("Random Delay==>"+randomNum+"\n");
								  }

														
							for(i = 0; i < d2; i++) { // aRow
							    for(j = 0; j < num_of_fail_nodes; j++) { // bColumn
							    	
							    	 System.out.print( result[i][j]+" ");						    	  
							   
							    }
							   
							    System.out.print("\n");	
							  }
							float[][] msr_result = new float[alpha][num_of_fail_nodes];
							
							for(i = 0; i < alpha; i++) { // aRow
							    for(j = 0; j < num_of_fail_nodes; j++) { // bColumn
							    	
							    	msr_result[i][j]  = (result[i][j]+(result[i+alpha][j]*delta[nodefail[j]-1][nodefail[j]-1])%p2)%p2;  	  
							   
							    }
							   
							    System.out.print("\n");	
							  }
							for(i = 0; i < alpha; i++) { // aRow
							    for(j = 0; j < num_of_fail_nodes; j++) { // bColumn
							    	
							    	 System.out.print( msr_result[i][j]+" ");						    	  
							   
							    }
							   
							    System.out.print("\n");	
							  }
							
							
							long Node_repair_endTime = System.currentTimeMillis();
							
							System.out.println("Data Reconstruction");	
							long file_construction_startTime = System.currentTimeMillis();
							int [] recon_nodes = new int [k2];
							i=0;
							while (i<k2){
								int random = (nodefail_generate.nextInt(n2)+1);
								System.out.print("\nrandom==>"+random+"\n");
						    	boolean flag = false;
						    	for (j=0;j<i;j++){
						    		if(recon_nodes[j]==random)
						    			flag=true;
						    	}
						    	if(flag)
						    	{
						    	}
						    	else {recon_nodes[i]=random;
						    	i++;
						    		
						    	}
														
							}
					        Arrays.sort(recon_nodes);
							System.out.print("\n Node number which will be contacted==>"+Arrays.toString(recon_nodes)+"\n");
							
							long [][] saiDC_M = new long[k2][alpha];
							 for(i=0;i<k2;i++){
							    	for(j=0;j<alpha;j++){
							    		saiDC_M[i][j] = C[recon_nodes[i]-1][j];
							    	}
							    	int randomNum = rand.nextInt(max - min + 1) + min;
								    try {
										Thread.sleep(randomNum);
									} catch (InterruptedException e2) {
										// TODO Auto-generated catch block
										e2.printStackTrace();
									}
									System.out.println("Random Delay==>"+randomNum+"\n");

					    }
						
							    	long [][] chiDC = new long[k2][alpha];
							   
								temp =0;
							    for(i=0;i<k2;i++){
							    	for(j=0;j<alpha;j++){
							    
							    		chiDC[i][j]=sai[recon_nodes[i]-1][j];
							    	}
							    }
							    long [][] P_deltaQ = new long[k2][k2];
							    for(i = 0; i < k2; i++) { // aRow
								    for(j = 0; j < k2; j++) { // bColumn
								    	for(int k=0;k<alpha;k++) {
								    		P_deltaQ [i][j] += (saiDC_M[i][k]*chiDC[j][k])%p2;							    	  
								    	}
								    	P_deltaQ[i][j]%=p2;
								    }
								  } 
							    
							    System.out.print( "saiDC_M"+"\n");
							    for(i = 0; i < k2; i++) { // aRow
								    for(j = 0; j < alpha; j++) { // bColumn
								    	
								    	 System.out.print( saiDC_M[i][j]+" ");						    	  
								   
								    }
								   
								    System.out.print("\n");	
								  }
							    System.out.print( "chiDC"+"\n");
							    for(i = 0; i < k2; i++) { // aRow
								    for(j = 0; j < alpha; j++) { // bColumn
								    	
								    	 System.out.print( chiDC[i][j]+" ");						    	  
								   
								    }
								   
								    System.out.print("\n");	
								  }
							 
							    System.out.print( "P_deltaQ"+"\n");
							    for(i = 0; i < k2; i++) { // aRow
								    for(j = 0; j < k2; j++) { // bColumn
								    	
								    	 System.out.print( P_deltaQ[i][j]+" ");						    	  
								   
								    }
								   
								    System.out.print("\n");	
								  }
							    long [][] deltaDC = new long[k2][k2];
							    for(i=0;i<k2;i++){
									
										deltaDC[i][i] = delta[recon_nodes[i]-1][recon_nodes[i]-1];
									
								}
							    System.out.print( "deltaDC"+"\n");
							    for(i = 0; i < k2; i++) { // aRow
								    for(j = 0; j < k2; j++) { // bColumn
								    	
								    	 System.out.print( deltaDC[i][j]+" ");						    	  
								   
								    }
								   
								    System.out.print("\n");	
								  }
							    
							    float [][] P = new float[k2][k2];
							    float [][] Q = new float[k2][k2];
							    
							    
							    int [] [] coeff = new int [2][2];
							    int [] [] coeff_inverse = new int [2][2];
							    
							    int [][] values = new int [2][1];
							    
							    
							    
							int a,b,c;
							    for(i = 0; i < k2; i++) { // aRow
								    for(j = 0; j < i; j++) {
								    	
								    	if(i!=j){
								    		System.out.print( "i="+i+" j="+j+"\n");

								    		int determinant =0;
								    		if((int) (deltaDC[j][j]-deltaDC[i][i])>0){
								    			
    		
								    		 determinant= (int) (deltaDC[j][j]-deltaDC[i][i])%p2;
								    		}
								    		else
								    		{
								    			determinant = field_add_inverse((int) (deltaDC[j][j]-deltaDC[i][i]),p2);
								    		}
								    		
								    		determinant = field_inverse(determinant,p2);
								    				
								    	coeff[0][0] = 1;
								    	coeff [0][1] = (int) deltaDC[i][i];
								    	coeff[1][0] = 1; 
								    	coeff[1][1] = (int) deltaDC[j][j];
								    	
								    	
								    	coeff_inverse[0][0] = (int) (deltaDC[j][j]*determinant)%p2; 
								    	coeff_inverse[0][1] = (field_add_inverse((int) (-1*deltaDC[i][i]),p2)*determinant)%p2;
								    	coeff_inverse[1][0] =(field_add_inverse((int) -1,p2)*determinant)%p2;
								    	coeff_inverse[1][1] = (1*determinant)%p2;
								    		
								    	values[0][0]= (int) P_deltaQ[i][j];
								    	values[1][0]= (int) P_deltaQ[j][i];
								    	System.out.print( "coeff"+"\n");
								    	   for(a = 0; a < 2; a++) { // aRow
											    for(b = 0; b < 2; b++) { // bColumn
											    	
											    	 System.out.print( coeff[a][b]+" ");						    	  
											   
											    }
											    
											    System.out.print("\n");	
											  }
								    	
								    	 System.out.print( "coeff_inverse"+"\n");
									    for(a = 0; a < 2; a++) { // aRow
										    for(b = 0; b < 2; b++) { // bColumn
										    	
										    	 System.out.print( coeff_inverse[a][b]+" ");						    	  
										   
										    }
										    
										    System.out.print("\n");	
										  }
									 
									   
									    System.out.print( "values"+"\n");
									    for(a = 0; a < 2; a++) { // aRow
										    for(b = 0; b < 1; b++) { // bColumn
										    	
										    	 System.out.print( values[a][b]+" ");						    	  
										   
										    }
										    
										    
										   
										    System.out.print("\n");	
										  }
									    int [][] solved = new int [2][1];
								    	 for(a = 0; a < 2; a++) { // aRow
											    for(b = 0; b <1; b++) {
											    	 for(c = 0; c < 2; c++){
													        solved [a][b] += ((coeff_inverse[a][c]*values[c][b])%p2);
													        System.out.print( "solved["+a+"]["+b+"]="+solved[a][b]+"\n");
											    		 
											    	 }
											    	 solved [a][b] %=p2;
											    }
											    	
											    }
								    	 System.out.print( "solved"+"\n");
								    	    for(a = 0; a < 2; a++) { // aRow
											    for(b = 0; b < 1; b++) { // bColumn
											    	
											    	 System.out.print( solved[a][b]+" ");						    	  
											   
											    }
											    
											    
											   
											    System.out.print("\n");	
											  }
								
								    	    P[i][j]=solved[0][0];
									    	 Q[i][j] = solved[1][0];
									    	 
									    	 P[j][i]=solved[0][0];
									    	 Q[j][i] = solved[1][0];
								    	
								    }
								    		
								      
								       
									    
								    	
								    }
								    
							    	
								    	
								    }
							    
							    
							    for(i = 0; i < k2; i++) { // aRow
								    for(j = 0; j < k2; j++) { // bColumn
								    	
								    	 System.out.print( P[i][j]+" ");						    	  
								   
								    }
								   
								    System.out.print("\n");	
								  }
						
							    for(i = 0; i < k2; i++) { // aRow
								    for(j = 0; j < k2; j++) { // bColumn
								    	
								    	 System.out.print( Q[i][j]+" ");						    	  
								   
								    }
								   
								    System.out.print("\n");	
								  }
							    int[][] P_i_chiDC_inverse = new int[k2][alpha];
							    int[][] Q_i_chiDC_inverse = new int[k2][alpha];
							    for(i = 0; i < k2; i++) { // aRow
								     
					
								    	int[] P_i = new int[k2-1];
								    	int[] Q_i = new int[k2-1];
								    	int k=0;
								    	for(j = 0; j < k2; j++){
								    		
								    	   if(i!=j){
								    		P_i[k]= (int) P[i][j];
								    		Q_i[k]= (int) Q[i][j];
								    		k++;
								    	   }
								    		
								    	}
								    	for(j = 0; j < k2-1; j++){
								    		
								    		 System.out.print(P_i[j]+ " ");
									    		
									    	}
								    	 System.out.print( "\n ");
								    	k=0;
								    	int[][] chiDC_right = new int[alpha][alpha];
								    	for(j = 0; j < k2; j++){
								    		for(int l = 0; l < alpha; l++){
									    	   if(j!=i)
									    	chiDC_right[k][l]= (int) chiDC[j][l];
								    		}
								    		if(j!=i)
								    		k++;
									    		
									    	}
								   	 System.out.print( "chiDC_right\n ");
								    	for(j = 0; j < alpha; j++){
								    		for(int l = 0; l < alpha; l++){
									    	  
								    			 System.out.print( chiDC_right[j][l]+" ");
								    		}
								    		System.out.print( "\n ");
									    		
									    	}
								    	int[][] chiDC_right_inverse = new int[alpha][alpha];
								    	vandermonde_inverse(chiDC_right,chiDC_right_inverse,p2);
								    	 System.out.print( "chiDC_right_inverse\n ");
								    	for(j = 0; j < alpha; j++){
								    		for(int l = 0; l < alpha; l++){
									    	  
								    			 System.out.print( chiDC_right_inverse[j][l]+" ");
								    		}
								    		System.out.print( "\n ");
									    		
									    	}
								    	
								    	
								    	for(a = 0; a < 1; a++) { // aRow
										    for(b = 0; b <alpha; b++) {
										    	 for(c = 0; c < alpha; c++){
										    		 P_i_chiDC_inverse [i][b] += ((P_i[c]*chiDC_right_inverse[b][c])%p2);
										    		 Q_i_chiDC_inverse [i][b] += ((Q_i[c]*chiDC_right_inverse[b][c])%p2);
												        System.out.print( "P_i_chiDC_inverse["+i+"]["+b+"]="+P_i_chiDC_inverse[i][b]+"\n");
										    		 
										    	 }
										    	 P_i_chiDC_inverse [i][b] %=p2;
										     	 Q_i_chiDC_inverse [i][b] %=p2;
										    }
										    	
										    }
								    	
								   
								   
								    System.out.print("\n");
							    }
							    
//							    System.out.print( "P_i_chiDC_inverse\n ");
						    	for(i = 0; i < k2; i++){
						    		for( j = 0; j < alpha; j++){
							    	  
						    			 System.out.print( P_i_chiDC_inverse[i][j]+" ");
						    		}
						    		System.out.print( "\n ");
							    		
							    	}
						    	int[][] chiDC_topalpha = new int[alpha][alpha];
						    	int[][] chiDC_topalpha_inverse = new int[alpha][alpha];
						    	int[][] recon_S1 = new int[alpha][alpha];
						    	int[][] recon_S2 = new int[alpha][alpha];
						    	for(i = 0; i < alpha; i++){
						    		for( j = 0; j < alpha; j++){
							    	  
						    			chiDC_topalpha[i][j]=(int) chiDC[i][j];
						    		}
						    	
							    		
							    	}
						    	
						    	vandermonde_inverse(chiDC_topalpha,chiDC_topalpha_inverse,p2);
						    	
						    	for(i = 0; i < alpha; i++){
						    		for( j = 0; j < alpha; j++){
						    			for(int  k = 0; k < alpha; k++){
						    				recon_S1[i][j]+=( chiDC_topalpha_inverse[i][k]*P_i_chiDC_inverse[k][j])%p2;
						    				recon_S2[i][j]+=( chiDC_topalpha_inverse[i][k]*Q_i_chiDC_inverse[k][j])%p2;
						    			}
						    			recon_S1[i][j]%=p2;
						    			recon_S2[i][j]%=p2;
						    		}
						    	
							    		
							    	}
						    	System.out.print("recon_S1\n");	
						    	for(i = 0; i < alpha; i++){
						    		for( j = 0; j < alpha; j++){
						    		 	System.out.print(recon_S1[i][j]+" ");	
						    			
						    		}
						    	System.out.print("\n");	
						    	}
						    	System.out.print("recon_S2\n");	
						    	for(i = 0; i < alpha; i++){
						    		for( j = 0; j < alpha; j++){
						    		 	System.out.print(recon_S2[i][j]+" ");	
						    			
						    		}
						    	System.out.print("\n");	
						    	}

						    	long [] recon_file_data = new long[B];
								 file_counter =0;
									
								 for(i = 0; i < alpha; i++) { // aRow
									    for(j = i; j < alpha ; j++) { 
									    	
									    	recon_file_data[file_counter] = (long) recon_S1 [i][j];
									    	if( recon_S1 [i][j]>0)
									    	file_counter++;
									    }
									   
								 }
								 
								 for(i = 0; i < alpha; i++) { // aRow
									    for(j = i; j < alpha ; j++) { 
									    	
									    	recon_file_data[file_counter] = (long) recon_S2 [i][j];
									    	if( recon_S2 [i][j]>0)
									    	file_counter++;
									    }
									   
								 }
								 
								 System.out.println("recon file data");

									System.out.println(Arrays.toString(recon_file_data));
									
									String strFilePath = path_output_jtextfield.getText();
									   
								     
								      FileOutputStream fos;
									
								      String strContent = "Write File using Java FileOutputStream example !";
								         
								     				     					     
								    
								   
								 
								 i=0;
								 try {
									fos = new FileOutputStream(strFilePath);
								System.out.println("\n"+file_counter+"\n");
							while(i<file_counter){
								
								 try {
									fos.write((char) (recon_file_data[i]));
								} catch (IOException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
								
								i++;
								
							}
						
							fos.close();
								 } catch (FileNotFoundException e1) {
										// TODO Auto-generated catch block
										e1.printStackTrace();
									} catch (IOException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
						
						long file_reconstruction_endTime = System.currentTimeMillis();
						
						out.write("This Simulation Report is based on the paper\nOptimal Exact-Regenerating Codes for Distributed storage at the MSR and MBR Points via a \nProduct-Matrix Construction \n K.V. Rashmi, Nihar B.Shah, and P.Vijay Kumar, Fellow, IEEE \n published in August 2011.\n");
											
						out.write("\nSimulation Report of MSR (Minimum Storage Regenerating) Points via a Product Matrix Multiplication\n");
						out.write("\n-------------------------------------------------------------------------------------\n");
						
						out.write("\n\nNumber of Nodes participating==> "+n2+"\n\n");
						out.write("\n\nnumber of Nodes used to reconstruct a file (k)==> "+k2+"\n\n");
						out.write("\n\nNumber of Nodes used to reconstruct a node (d)==> "+d2+"\n\n");
						out.write("\n\nMaximum File Size the cloud can store (B)==> "+B+"\n\n");
						out.write("\n\nNumber of Chunks Stored at each node (alpha)==>"+alpha+"\n\n");
						out.write("\n\nChunk size is 1 Byte\n\n");
						
						out.write("Message Matrix==>\n\n");
						
						for(i=0;i<d2;i++){
							
						
							for(j=0;j<alpha;j++)
							{
								
								out.write(M[i][j]+"\t");
						
							}
							
							out.write("\n");
						}
						
						out.write("\n");

						
						out.write("Vandermonde Matrix==>\n");
						for(x=0;x<n2;x++)
						{
							
						
							for(y=0;y<d2;y++)
							{
						
								out.write(sai[x][y]+"\t");
							}
						
						out.write("\n");
						}
						
						out.write("\n");
						
						out.write("C matrix==>\n");
						
						for(i = 0; i < n2; i++) { // aRow
						
							for(j = 0; j < alpha; j++) { // bColumn
						   	       out.write(C[i][j]+"\t");
						        
						      }
						    out.write("\n\n");
						    }
						
						
						
						out.write("\nNode Repair\n");
						out.write("\n-----------\n");
						
							
						
						out.write("\nNodes participating and data stored in it==>\n\n");
						
						for(i = 0; i < n2; i++) { // aRow
							System.out.print("Node "+(i+1)+"==>");
							out.write("Node "+(i+1)+"==>");
						    for(j = 0; j < alpha; j++) { // bColumn
						   	       
						   	       out.write(" "+C[i][j]+"\t");
						      }
						    
						    out.write("\n\n");
						    }
						
						
						out.write("\nNumber of Nodes failed==>"+num_of_fail_nodes+"\n");
						
						
						out.write("\nNode number which is failed ==> "+Arrays.toString(nodefail)+"\n\n");
						
						
						for( i=0;i<num_of_fail_nodes;i++){
						
							out.write("Node "+nodefail[i]+" ==>");
					    	for(j=0;j<alpha;j++){
					    		
					    
					    	out.write(" "+C[nodefail[i]-1][j]+"\t");
					    }
					    
					    	out.write("\n\n");
					    }
						
						
						out.write("\n Nodes number which are required to repair ==>"+Arrays.toString(contactnode)+"\n\n");
										
						out.write("\n Nodes which are required to repair ==>\n\n");
						
						 for(i=0;i<d2;i++){
						
								out.write("Node "+contactnode[i]+" ==>");
						    	for(j=0;j<alpha;j++){
						
						    		out.write(" "+ y2[i][j]+"\t");
						    	}
						    	
						    		
						    		out.write("\n\n");
						    }
						 
						 
						 out.write("\n After repair, nodes which are failed are ==> \n");
						 
						 
						 for(i = 0; i < num_of_fail_nodes; i++) { // aRow
						
								out.write("Node "+nodefail[i]+" ==>");
							    for(j = 0; j < alpha; j++) { // bColumn
							    	
												    	  
							    	 out.write(" " + msr_result[j][i]+"\t");
							    }
							   
							    
							    out.write("\n\n");
							  }
						 
						 
						 
						  
						 out.write("\nNode repair Time == > :"+ (Node_repair_endTime-Node_repair_startTime)); 
						 
						 
						 out.write("\n----------------------------------------------------------------------------------");
						
						 
						 
						 
						 out.write("\nData Reconstruction\n");
						 
						 out.write("\n-------------------\n");
						 
						 
						 out.write("\nData which is stored in the Nodes are == > \n\n");
						 
						 out.write(Arrays.toString(file_data));
						 
						 
						 out.write("\n Node number which will be contacted==>\n"+Arrays.toString(recon_nodes)+"\n");
						 
						 
						 out.write("\n Node which will be contacted are ==>\n\n");
						 
						 for( i=0;i<recon_nodes.length;i++){
							 
								out.write("Node "+recon_nodes[i]+" ==>");
						    	for(j=0;j<alpha;j++){
						    		
						    
						    	out.write(" "+C[recon_nodes[i]-1][j]+"\t");
						    }
						    
						    	out.write("\n\n");
						    }
						 
						 
						 out.write("\nAfter Data Reconstruction\n\n");
						 
						 out.write("\n-------------------\n\n");
						 
						 out.write("\nReconstructed file data==>\n");
						 
						 out.write(Arrays.toString(recon_file_data));
						 
						 
						 
						 
						 
						
						
						
						
						
						
						
						
						
							out.write("\nFile Reconstruction Time == > :"+ (file_reconstruction_endTime-file_construction_startTime)+"\n\n");
							
						
							out.write("\nFile upload time == > :"+ (File_upload_endTime-File_upload_startTime)+"\n\n");
								
							float repair_bandwidth = (d2*B)/(k2*(d2-k2+1));
							
							System.out.println("\nRepair Bandwidth == > :"+repair_bandwidth+"\n\n");
							out.write("\nRepair Bandwidth == > :"+repair_bandwidth+"\n\n");
						
						
						out.close();
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
							
								 
								 
						
								 
					}
					else
					{
						alpha =0;
						B = 0;
						alpha_jtextfield.setVisible(true);
						alpha_jlabel.setVisible(true);
						B_jtextfield.setVisible(true);
						B_jlabel.setVisible(true);
						alpha_jtextfield.setText("0");
						B_jtextfield.setText("0");
						
						
						
					}
					
					
				
				
				}
				
			
				
			}
			
		
	
	
	
	static int fact(int n) {
		
		
		if (n <= 1) {
		    return 1;
		}
		
		else {
		    return n * fact(n-1);
		}
	    }
		
	int prime(int num){
		
		  int i;
		  int flag_prime =0;
		  for (i=2; i < num ;i++ ){
		  int n = num%i;
		  if (n==0){
		  break;
		  }
		  }
		  if(i == num){
		  flag_prime=1;
		  }
		
		return flag_prime;
		
	}
	
	void vandermonde_inverse(int [] [] vandermonde_matrix, int [] [] inverse_vandermonde_matrix,int p2)
	{
		int i,j=0;
		
		int n2=vandermonde_matrix.length;
	  
	  	  
	  
	  for(i=0;i<n2;i++){
		  for(j=0;j<n2;j++){
		  
			  int denominator = 1;
			  for(int m=0 ;m<n2;m++){
				  	  if(m==j)
						  continue;
				  	  if((vandermonde_matrix[m][1]-vandermonde_matrix[j][1])<0)
				  	denominator *=field_add_inverse(vandermonde_matrix[m][1]-vandermonde_matrix[j][1],p2);
				  	  else
				  	 	denominator *=vandermonde_matrix[m][1]-vandermonde_matrix[j][1];
				  	  
				  	denominator %=p2;
				  	  

				  	  
			  }
			  denominator %=p2;
			  denominator = field_inverse(denominator,p2);
			   
			//----denominator is ready-------//
			  int numerator = 0; 
			  if(n2-i-1==0){
				  numerator=1;
				  }
			  else{
			  int[][] combinations = getCombinations(n2-i-1, n2-1,j);
			  int each_part_of_numerator = 1;
			
			  
			  for (int r = 0; r < combinations.length; r++)
		        {
		            for (int s = 0; s < combinations[r].length; s++)
		            {
		            	each_part_of_numerator *= vandermonde_matrix[combinations[r][s]][1];
		            	each_part_of_numerator%=p2;
		            	
		            }
		            each_part_of_numerator%=p2;
		            numerator+=each_part_of_numerator;
		            each_part_of_numerator=1;
		            
		        }
			  numerator%=p2;
			  }  
			  
			  inverse_vandermonde_matrix[i][j] = (numerator* denominator)%p2;
			  

		       if(n2%2==0){ 
		                  if((n2-i)%2!=0){
		                      
		                      inverse_vandermonde_matrix[i][j]=field_add_inverse(-1*inverse_vandermonde_matrix[i][j],p2);
		                      
		                  }
		                 }
		                 else{
		                     
		                     if((n2-i)%2==0){
		                         
		                         inverse_vandermonde_matrix[i][j]=field_add_inverse(-1*inverse_vandermonde_matrix[i][j],p2);
		                         
		                     }
		                     
		                 }

			  
			  
			  
			  
		  }
	  }
	  
	  
	  
	    
 }
 
 static int field_inverse(int denominator,int p2){
	  int temp=0;
	  for(int i=0;i<p2;i++){
		  if((denominator*i)%p2==1){
			  temp = i;
			  break;
		  }
	  
	  }
	  
	  return temp;
 }
 
 static int field_add_inverse(int denominator,int p2){
	 while(denominator<0){
		 
		 denominator+=p2;
	 }
	 return denominator;
 }
 
 private static int[][] getCombinations(int num, int outOf,int k)
   {
       int possibilities = get_nCr(outOf, num);
       int[][] combinations = new int[possibilities][num];
       int arrayPointer = 0;

       int[] counter = new int[num];

       for (int i = 0; i < num; i++)
       {
           counter[i] = i;
       }
       breakLoop: while (true)
       {
           // Initializing part
           for (int i = 1; i < num; i++)
           {
               if (counter[i] >= outOf - (num - 1 - i))
                   counter[i] = counter[i - 1] + 1;
           }

           // Testing part
           for (int i = 0; i < num; i++)
           {
               if (counter[i] < outOf)
               {
                   continue;
               } else
               {
                   break breakLoop;
               }
           }

           // Innermost part
           combinations[arrayPointer] = counter.clone();
           arrayPointer++;

           // Incrementing part
           counter[num - 1]++;
           for (int i = num - 1; i >= 1; i--)
           {
               if (counter[i] >= outOf - (num - 1 - i))
                   counter[i - 1]++;
           }
       }
       for (int i = 0; i < combinations.length; i++)
       {
           for (int j = 0; j < combinations[i].length; j++)
           {
             if(combinations[i][j]==k)
           	  combinations[i][j]=outOf;
           }
           
       }
       return combinations;
   }

   private static int get_nCr(int n, int r)
   {
       if(r > n)
       {
           throw new ArithmeticException("r is greater then n");
       }
       long numerator = 1;
       long denominator = 1;
       for (int i = n; i >= r + 1; i--)
       {
           numerator *= i;
       }
       for (int i = 2; i <= n - r; i++)
       {
           denominator *= i;
       }

       return (int) (numerator / denominator);
   }
   
   class OpenAction implements ActionListener {
       public String filename;

	public void actionPerformed(ActionEvent ae) {
    
           int retval = _fileChooser.showOpenDialog(productmatrix.this);
           if (retval == JFileChooser.APPROVE_OPTION) {
    
               File file = _fileChooser.getSelectedFile();

    
               _fileNameTF.setText(file.getPath());
                filename = file.getPath();
           }
       }
   }
   
   
   class GenerateValues implements ActionListener {
       
       int k2,d2,alpha,B;

	public void actionPerformed(ActionEvent ae) {
		
		k2=Integer.parseInt(k1.getText());
		d2=2*(k2-1);
		
		alpha = k2-1;
		B = (alpha*(alpha+1));
		
		
		alpha_jtextfield.setVisible(true);
		alpha_jlabel.setVisible(true);
		B_jtextfield.setVisible(true);
		B_jlabel.setVisible(true);
		d_jtextfield.setVisible(true);
		d_jlabel.setVisible(true);
		alpha_jtextfield.setText(""+alpha);
		B_jtextfield.setText(""+B);
		d_jtextfield.setText(""+d2);
       
		
		
		
       }
   }
		
	}


	
	
	


